package lrs.visitor;
import lrs.*;

/**
 * Weaves ("Zips") together any two LRStructs even if they
 * share any node to yield two completely distinct LRStructs 
 * with the same data.
 * For example, when we zip (5, 3, 9), the host, together
 * with (-7, 0, 8, -15), the input parameter, both lists
 * become (5, -7, 3, 0, 9, 8, -15).
 */

public class BetterZipper implements IAlgo {
  public static final BetterZipper Singleton = new BetterZipper();
  private BetterZipper() {
  }
  

  
  /**
   * host is empty, so there is nothing to zip with.
   * Just copy the input list to here
   * @param host empty
   * @param input [0] the other LRStruct.
   * @return The mutated host list
   */
  public Object emptyCase(LRStruct host, Object... otherList) {
    // STUDENT TO COMPLETE
    
    return null;
  }
  
  
  /**
   * Zip the other list into this host list, mutating both lists
   * to hold the same elements but without sharing any nodes. 
   * @param host not empty
   * @param input [0] the other LRStruct.
   * @return The mutated host list.
   */
  public Object nonEmptyCase(LRStruct host, Object... otherList) {
    // STUDENT TO COMPLETE

    return null;
  }
}

